'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Content = function (_React$Component) {
  _inherits(Content, _React$Component);

  function Content() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Content);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Content.__proto__ || Object.getPrototypeOf(Content)).call.apply(_ref, [this].concat(args))), _this), _this.refNode = function (node) {
      _this.node = node;
    }, _this.contentHasFocus = function () {
      return document.activeElement === _this.node || _this.node.contains(document.activeElement);
    }, _this.handleKeyDown = function (event) {
      if (_this.props.closeOnEsc && event.keyCode === 27) {
        if (_this.contentHasFocus()) {
          event.stopPropagation();

          _this.props.onRequestClose(event);
        }
      }
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Content, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          children = _props.children,
          className = _props.className;


      return _react2.default.createElement(
        'div',
        {
          ref: this.refNode,
          tabIndex: '-1',
          style: this.style,
          onKeyDown: this.handleKeyDown,
          className: className
        },
        children
      );
    }
  }, {
    key: 'style',
    get: function get() {
      var defaultStyles = Content.defaultStyles;
      var styles = this.props.style;

      if (!styles) {
        return defaultStyles;
      }

      return Object.assign({}, defaultStyles, styles);
    }
  }]);

  return Content;
}(_react2.default.Component);

Content.defaultStyles = {
  position: 'absolute',
  top: '100px',
  left: '100px',
  right: '100px',
  bottom: '100px',
  background: '#fff',
  overflow: 'auto',
  WebkitOverflowScrolling: 'touch',
  outline: 'none',
  padding: '20px',
  border: '1px solid #ddd'
};
Content.defaultProps = {
  closeOnEsc: false
};
Content.propTypes = {
  className: _propTypes2.default.string,
  style: _propTypes2.default.object,
  children: _propTypes2.default.node,
  closeOnEsc: _propTypes2.default.bool,
  onRequestClose: _propTypes2.default.func.isRequired
};
exports.default = Content;